PROGRAM MOUSE

!$KEY
!$INCLUDE="PC.LIB"

PROCEDURE INITASM
!
! LOAD ASSEMBLY LANGUAGE SUBROUTINE
!
    !$RCODE="DEF SEG=&H4B"
    OPEN("I",1,"ASM.DAT")
       FOR I=0 TO 53
         INPUT(#1,B)
         POKE(I,B)
       END FOR
    CLOSE(1)
    !$RCODE="DEF SEG"
END PROCEDURE

PROCEDURE EXECUTEASM
      !$RCODE="DEF SEG=&H4B"
      !$RCODE="POKE 33,INTERRUPT%"
      !$RCODE="POKE 4,INT(REGAX%/256):POKE 3,REGAX% MOD 256"
      !$RCODE="POKE 6,INT(REGBX%/256):POKE 5,REGBX% MOD 256"
      !$RCODE="POKE 8,INT(REGCX%/256):POKE 7,REGCX% MOD 256"
      !$RCODE="POKE 10,INT(REGDX%/256):POKE 9,REGDX% MOD 256"
      !$RCODE="ASMSUB=0:CALL ASMSUB"
      ! CALL ABSOLUTE(0)  USE THIS LINE FOR THE COMPILER
      !$RCODE="REGAX=(PEEK(4)*256)+PEEK(3):IF REGAX>32767 THEN REGAX=REGAX-65536!"
      !$RCODE="REGAX%=REGAX"
      !$RCODE="REGBX=(PEEK(6)*256)+PEEK(5):IF REGBX>32767 THEN REGBX=REGBX-65536!"
      !$RCODE="REGBX%=REGBX"
      !$RCODE="REGCX=(PEEK(8)*256)+PEEK(7):IF REGCX>32767 THEN REGCX=REGCX-65536!"
      !$RCODE="REGCX%=REGCX"
      !$RCODE="REGDX=(PEEK(10)*256)+PEEK(9):IF REGDX>32767 THEN REGDX=REGDX-65536!"
      !$RCODE="REGDX%=REGDX"
      !$RCODE="DEF SEG"
END PROCEDURE

PROCEDURE GETMONITORTYPE
      !$RCODE="DEF SEG=0"
      STATUS=PEEK($463)
      !$RCODE="DEF SEG"
      MONITOR$=""
      IF STATUS=$B4 THEN
         !$RCODE="STATUS=(INP(&H3BA) AND &H80)"
         FOR DELAYLOOP=1 TO 30000
             !$RCODE="XX=((INP(&H3BA) AND &H80)<>STATUS)"
             IF XX THEN MONITOR$="HERC" END IF
         END FOR
         IF MONITOR$="" THEN MONITOR$="MONO" END IF
       ELSE
          REGAX%=$1A00
          INTERRUPT%=$10
          EXECUTEASM
          IF (REGAX% AND $FF)=$1A THEN
                MONITOR$="VGA"
             ELSE
                REGAX%=$1200  REGBX%=$10
                INTERRUPT%=$10
                EXECUTEASM
                IF (REGBX% AND $FF)=$10 THEN
                     MONITOR$="CGA"
                  ELSE
                     MONITOR$="EGA"
                END IF
          END IF
      END IF
END PROCEDURE

PROCEDURE MOUSERESETANDSTATUS
      REGAX%=0  REGBX%=0  REGCX%=0  REGDX%=0
      INTERRUPT%=$33
      EXECUTEASM
      STATUS=REGAX% BUTTONS=REGBX%
END PROCEDURE

PROCEDURE MOUSESHOWCURSOR
      REGAX%=1
      INTERRUPT%=$33
      EXECUTEASM
END PROCEDURE

PROCEDURE MOUSEHIDECURSOR
      REGAX%=2
      INTERRUPT%=$33
      EXECUTEASM
END PROCEDURE

PROCEDURE MOUSEGETCURSORPOSITION
      REGAX%=3
      INTERRUPT%=$33
      EXECUTEASM
      X=REGCX%  Y=REGDX%
      LEFT=0  RIGHT=0  BOTH=0  MIDDLE=0
      IF (REGBX% AND 7)=0 THEN
          ! NULL
        ELSE
          T=TIMER
          WHILE TIMER<T+DELAY
          END WHILE
          IF (REGBX% AND 7)=1 THEN LEFT=-1 END IF
          IF (REGBX% AND 7)=2 THEN RIGHT=-1 END IF
          IF (REGBX% AND 7)=3 THEN BOTH=-1 END IF
          IF (REGBX% AND 7)=4 THEN MIDDLE=-1 END IF
      END IF
END PROCEDURE

PROCEDURE MOUSESETCURSORPOSITION
      REGAX%=4  REGCX%=X  REGDX%=Y
      INTERRUPT%=$33
      EXECUTEASM
END PROCEDURE

PROCEDURE MOUSEGETBUTTONPRESSINFO
      REGAX%=5  REGBX%=BUTTON
      INTERRUPT%=$33
      EXECUTEASM
      STATUS=REGAX%  BUTTONS=REGBX%  XPOS=REGCX%  YPOS=REGDX%
END PROCEDURE

PROCEDURE MOUSEGETBUTTONRELEASEINFO
      REGAX%=6  REGBX%=BUTTON
      INTERRUPT%=$33
      EXECUTEASM
      STATUS=REGAX%  BUTTONS=REGBX%  XPOS=REGCX%  YPOS=REGDX%
END PROCEDURE

PROCEDURE MOUSESETCURSORLIMITS
      REGAX%=7  REGBX%=0  REGCX%=LEFTLIMIT  REGDX%=RIGHTLIMIT
      ! HORIZONTAL
      INTERRUPT%=$33
      EXECUTEASM

      REGAX%=8  REGBX%=0  REGCX%=TOPLIMIT  REGDX%=BOTTOMLIMIT
      ! VERTICAL
      INTERRUPT%=$33
      EXECUTEASM
END PROCEDURE

PROCEDURE MOUSESETEXTCURSOR
      REGAX%=10
      ! SET TEXT CURSOR
      REGBX%=0
      ! SOFTWARE TEXT CURSOR
      REGCX%=$7FFF
      REGDX%=$7700
      INTERRUPT%=$33
      EXECUTEASM
END PROCEDURE

PROCEDURE MOUSEREADMOTIONCOUNTERS
      REGAX%=11
      INTERRUPT%=$33
      EXECUTEASM
      XMICKEY=REGCX%  YMICKEY=REGDX%
END PROCEDURE

PROCEDURE MOUSESETSENSITIVITY
      REGAX%=26  REGBX%=XSENS  REGCX%=YSENS  REGDX%=THRESHOLD
      INTERRUPT%=$33
      EXECUTEASM
END PROCEDURE

PROCEDURE MOUSEGETINFO
      REGAX%=36
      INTERRUPT%=$33
      EXECUTEASM
      !$RCODE="VERSION=VAL(HEX$(INT(REGBX%/256))+"."+HEX$(REGBX% MOD 256))"
      !$RCODE="MOUSETYPE=INT(REGCX%/256)"
      !$RCODE="IRQ=REGCX% MOD 256"
END PROCEDURE

BEGIN
    INITASM
    GETMONITORTYPE
    COLOR(7,0)
    CLS
    LOCATE(1,50)  PRINT("MONITOR TYPE  ";MONITOR$)
    MOUSERESETANDSTATUS
    IF STATUS<>-1 THEN
        BEEP
        CLS
        PRINT("MOUSE DRIVER NOT INSTALLED OR MOUSE NOT FOUND")
        REPEAT
           GET(IN$)
        UNTIL IN$<>""
     ELSE
        MOUSESETEXTCURSOR
        TOPLIMIT=8  BOTTOMLIMIT=199  LEFTLIMIT=0  RIGHTLIMIT=639
        MOUSESETCURSORLIMITS
        XSENS=30  YSENS=30  THRESHOLD=50
        MOUSESETSENSITIVITY
        MOUSESHOWCURSOR
        REPEAT
          OLDX=X  OLDY=Y
          MOUSEGETCURSORPOSITION
          GET(IN$)
          COLOR(15,0)
          LOCATE(1,2)
          PRINT("X =";X;"  Y =";Y;"  ";)
          IF LEFT   THEN LOCATE(1,37) COLOR(10,0)  PRINT("LEFT";) END IF
          IF RIGHT  THEN LOCATE(1,37) COLOR(12,0)  PRINT("RIGHT";) END IF
          IF MIDDLE THEN LOCATE(1,37) COLOR(14,0)  PRINT("MIDDLE";) END IF
          IF NOT RIGHT AND NOT LEFT AND NOT MIDDLE THEN
              LOCATE(1,37)  PRINT("       ";)
          END IF
          IF NOT (X=OLDX AND Y=OLDY) THEN MOUSESHOWCURSOR END IF
        UNTIL IN$=CHR$(27)
   END IF
   MOUSEHIDECURSOR
   CLS
END PROGRAM

